#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vip_core>

#pragma semicolon 1

new IsBleeding[MAXPLAYERS+1];
new WhoOpened[MAXPLAYERS+1];
new Bandages[MAXPLAYERS+1];

new Handle:g_hPrice, g_iPrice,
	Handle:g_hSellPrice, g_iSellPrice,
	Handle:g_hChance, g_iChance,
	Handle:g_hTimer, Float:g_iTimer,
	Handle:g_hHealth, g_iHealth;

static const char g_sFeature[] = "AutoBandage";

#define VIP_UseBandage 1

public Plugin:myinfo = 
{ 
	name = "[VIP] Bleeding", 
	author = "Dream", 
	description = "Add bleeding to server", 
	version = "1.31", 
} 

public OnPluginStart()
{
	HookEvent("player_spawn", Spawn);
	
	RegConsoleCmd("sm_bandage", Command_Bandage);
	RegConsoleCmd("sm_b", Command_Bandage);
	
	RegConsoleCmd("sm_buybandage", Command_BuyBandage);
	RegConsoleCmd("sm_buyb", Command_BuyBandage);
	
	RegConsoleCmd("sm_sellbandage", Command_SellBandage);
	RegConsoleCmd("sm_sellb", Command_SellBandage);
	RegConsoleCmd("sm_myb", Command_MyBandage);
	
	g_hPrice = CreateConVar("sm_shop_bandage_price", "100", "Price of bandage.");
	g_iPrice = GetConVarInt(g_hPrice);
	HookConVarChange(g_hPrice, OnConVarChange);
	
	g_hSellPrice = CreateConVar("sm_shop_bandage_sellprice", "80", "Sellprice of bandage.");
	g_iSellPrice = GetConVarInt(g_hSellPrice);
	HookConVarChange(g_hSellPrice, OnConVarChange);
	
	g_hChance = CreateConVar("sm_shop_bandage_chance", "20", "Chance to bleed.");
	g_iChance = GetConVarInt(g_hChance);
	HookConVarChange(g_hChance, OnConVarChange);
	
	g_hTimer = CreateConVar("sm_shop_bandage_timer", "2.0", "Time, when player's health is reducing(seconds).");
	g_iTimer = GetConVarFloat(g_hTimer);
	HookConVarChange(g_hTimer, OnConVarChange);
	
	g_hHealth = CreateConVar("sm_shop_bandage_health", "1", "How many HP player lose per N seconds.");
	g_iHealth = GetConVarInt(g_hHealth);
	HookConVarChange(g_hHealth, OnConVarChange);

	AutoExecConfig(true, "bleeding");
	
	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
}

public OnConVarChange(Handle:hCvar, const String:oldValue[], const String:newValue[])
{
	if(hCvar == g_hPrice) 
		g_iPrice = StringToInt(newValue);
	else if(hCvar == g_hSellPrice) 
		g_iSellPrice = StringToInt(newValue);
	else if(hCvar == g_hChance)
		g_iChance = StringToInt(newValue);
	else if(hCvar == g_hTimer) 
		g_iTimer = StringToFloat(newValue);
	else if(hCvar == g_hHealth) 
		g_iHealth = StringToInt(newValue);
}

public OnPluginEnd() 
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
	{
		VIP_UnregisterFeature(g_sFeature);
	}
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, INT);
}

public OnClientPostAdminCheck (client)
{
	SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
	Bandages[client] = 0;
}

public Action:Spawn(Handle:event, const String:name[], bool:db)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	IsBleeding[client] = 0;
	WhoOpened[client] = 0;
	return Plugin_Handled;
}

public Action:OnTakeDamage(int victim, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if(damagetype == 4098 && victim && attacker && !IsBleeding[victim] && GetClientTeam(victim) != GetClientTeam(attacker))
	{
		new bleeding = GetRandomInt(0,100);
		if(bleeding < g_iChance)
		{
			if(VIP_IsClientVIP(victim) && VIP_IsClientFeatureUse(victim, g_sFeature)) 
			{
				new iFlag = VIP_GetClientFeatureInt(victim, g_sFeature);
				if(iFlag == VIP_UseBandage) 
				{
					if(Bandages[victim]) Bandages[victim]--;
					else 
					{
						PrintCenterText(victim, "Открылось кровотечение! У вас %d бинтов", Bandages[victim]);
						IsBleeding[victim] = 1;
						WhoOpened[victim] = attacker;
						CreateTimer(g_iTimer, BleedTimer, victim, TIMER_FLAG_NO_MAPCHANGE);
					}
				}
			}
			else 
			{
				PrintCenterText(victim, "Открылось кровотечение! У вас %d бинтов", Bandages[victim]);
				IsBleeding[victim] = 1;
				WhoOpened[victim] = attacker;
				CreateTimer(g_iTimer, BleedTimer, victim, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
}
	
public Action:BleedTimer(Handle:timer, client) 
{ 
	if(IsClientAuthorized(client))
	{
		if(IsBleeding[client] == 0)
		{
			WhoOpened[client] = 0;
			return Plugin_Stop;
		}
		new pHealth = GetEntProp(client, Prop_Send, "m_iHealth");
		if(pHealth <= g_iHealth)
		{
			ForcePlayerSuicide(client);
			IsBleeding[client] = 0;
			SetEntProp(client, Prop_Data, "m_iFrags", GetClientFrags(client)+1);
			if(IsClientAuthorized(WhoOpened[client]))
			{
				SetEntProp(WhoOpened[client], Prop_Data, "m_iFrags", GetClientFrags(WhoOpened[client])+1);
			}
			return Plugin_Stop;
		}
		SetEntProp(client, Prop_Send, "m_iHealth", pHealth-g_iHealth);
		CreateTimer(g_iTimer, BleedTimer, client, TIMER_FLAG_NO_MAPCHANGE);
	}
	return Plugin_Continue;
}

public Bandage_SelectMenu(Handle:selectmenu, MenuAction:action, client, option)
{
	if (action == MenuAction_Select)
	{
		decl String:userid[15];
		userid[0] = '\0';
		GetMenuItem(selectmenu, option, userid, 15); 
		new target = GetClientOfUserId(StringToInt(userid)); 
		decl Float:pos1[3], Float:pos2[3];
		GetClientAbsOrigin(client, pos1);
		GetClientAbsOrigin(target, pos2);
		if (GetVectorDistance(pos1, pos2) > 70.0)
		{
			PrintToChat(client, "\x04[ERROR] \x03Вы далеко от игрока!");
		}
		else
		{
			IsBleeding[target] = 0;
			Bandages[client]--;
			PrintToChat(client, "\x04[BANDAGE] \x03У вас осталось %d бинтов.", Bandages[client]);
		}
	}
	else if (action == MenuAction_End && action == MenuAction_Cancel)
	{
		CloseHandle(selectmenu);
	}
}

public Action:Command_BuyBandage(client, args)
{
	new money = GetEntProp(client, Prop_Send, "m_iAccount");
	if(money < g_iPrice)
	{
		PrintToChat(client, "\x04[ERROR] \x03У вас не хватает денег! Для покупки нужно минимум $%d.", g_iPrice);
		return Plugin_Stop;
	}
	Bandages[client]++;
	SetEntProp(client, Prop_Send, "m_iAccount", money-g_iPrice);
	PrintToChat(client, "\x04[BANDAGE] \x03У вас теперь %d бинтов.", Bandages[client]);
	return Plugin_Continue;
}

public Action:Command_SellBandage(client, args)
{
	if(!Bandages[client])
	{
		PrintToChat(client, "\x04[ERROR] \x03У вас нет бинтов!");
		return Plugin_Stop;
	}
	new money = GetEntProp(client, Prop_Send, "m_iAccount");
	Bandages[client]--;
	SetEntProp(client, Prop_Send, "m_iAccount", money+g_iSellPrice);
	PrintToChat(client, "\x04[BANDAGE] \x03У вас осталось %d бинтов.", Bandages[client]);
	return Plugin_Continue;
}

public Action:Command_MyBandage(client, args)
{
	PrintToChat(client, "\x04[BANDAGE] \x03У вас %d бинтов.", Bandages[client]);
	return Plugin_Continue;
}

public Action:Command_Bandage(client, args)
{
	if(!Bandages[client])
	{
		PrintToChat(client, "\x04[ERROR] \x03У вас нет бинтов!");
		return Plugin_Stop;
	}
	
	if (IsPlayerAlive(client))
	{
		new Handle:selectmenu = CreateMenu(Bandage_SelectMenu);
		SetMenuTitle(selectmenu, "Кого бинтуем?");
		char name[MAX_NAME_LENGTH];
		decl String:userid[15];
		userid[0] = '\0';
		for (new target; target <= MaxClients; target++)
		{
			if(IsBleeding[target] && GetClientTeam(client) == GetClientTeam(target))
			{
				decl Float:pos1[3], Float:pos2[3];
				GetClientAbsOrigin(client, pos1);
				GetClientAbsOrigin(target, pos2);
				if (GetVectorDistance(pos1, pos2) <= 70.0)
				{
					GetClientName(target, name, sizeof(name));
					IntToString(GetClientUserId(target), userid, 15); 
					AddMenuItem(selectmenu, userid, name);
				}
			}
		}
		SetMenuExitButton(selectmenu, true);
		DisplayMenu(selectmenu, client, 0);
	}
	else PrintToChat(client, "\x04[ERROR] \x03Вы мертвы!");
	return Plugin_Continue;
}